<?php
// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2010      Pierrick LE GALL             http://piwigo.org |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if( !defined("PHPWG_ROOT_PATH") )
{
  die ("Hacking attempt!");
}

include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
include_once(UPLOAD_FORM_PATH.'include/functions_upload.inc.php');
load_language('plugin.lang', UPLOAD_FORM_PATH);

$admin_base_url = get_root_url().'admin.php?page=plugin&section=upload_form%2Fupload.php';

// +-----------------------------------------------------------------------+
// | Check Access and exit when user status is not ok                      |
// +-----------------------------------------------------------------------+
check_status(ACCESS_ADMINISTRATOR);

// +-----------------------------------------------------------------------+
// |                             process form                              |
// +-----------------------------------------------------------------------+

if (isset($_POST['submit_upload']))
{
  $category_id = null;
  if ('existing' == $_POST['category_type'])
  {
    $category_id = $_POST['category'];
  }
  elseif ('new' == $_POST['category_type'])
  {
    $output_create = create_virtual_category(
      $_POST['category_name'],
      (0 == $_POST['category_parent'] ? null : $_POST['category_parent'])
      );

    if (isset($output_create['error']))
    {
      array_push($page['errors'], $output_create['error']);
    }
    else
    {
      // information
      array_push(
        $page['infos'],
        sprintf(
          l10n('Category "%s" has been added'),
          '<em>'.get_cat_display_name_from_id($output_create['id']).'</em>'
          )
        );
    }

    $category_id = $output_create['id'];
  }
  
  $starttime = get_moment();
  
  foreach ($_FILES['image_upload']['error'] as $idx => $error)
  {
    if (UPLOAD_ERR_OK == $error)
    {
      $source_filepath = $_FILES['image_upload']['tmp_name'][$idx];
      $original_filename = $_FILES['image_upload']['name'][$idx];
      add_uploaded_file($source_filepath, $original_filename, array($category_id));
    }
  }
  
  $endtime = get_moment();
  $elapsed = ($endtime - $starttime) * 1000;
  // printf('%.2f ms', $elapsed);
}

// +-----------------------------------------------------------------------+
// |                             template init                             |
// +-----------------------------------------------------------------------+

$template->set_filenames(
  array(
    'plugin_admin_content' => dirname(__FILE__).'/upload.tpl'
    )
  );

$template->assign(
    array(
      'F_ADD_ACTION'=> $admin_base_url,
      'plugin_path' => UPLOAD_FORM_PATH,
    )
  );

$query = '
SELECT id,name,uppercats,global_rank
  FROM '.CATEGORIES_TABLE.'
;';

display_select_cat_wrapper(
  $query,
  array(),
  'category_options'
  );

// +-----------------------------------------------------------------------+
// |                             setup errors                              |
// +-----------------------------------------------------------------------+

$setup_errors = array();

$upload_base_dir = 'upload';
$upload_dir = PHPWG_ROOT_PATH.$upload_base_dir;

if (!is_dir($upload_dir))
{
  if (!is_writable(PHPWG_ROOT_PATH))
  {
    array_push(
      $setup_errors,
      sprintf(
        l10n('Create the "%s" directory at the root of your Piwigo installation'),
        $upload_base_dir
        )
      );
  }
}
else
{
  if (!is_writable($upload_dir))
  {
    @chmod($upload_dir, 0777);

    if (!is_writable($upload_dir))
    {
      array_push(
        $setup_errors,
        sprintf(
          l10n('Give write access (chmod 777) to "%s" directory at the root of your Piwigo installation'),
          $upload_base_dir
          )
        );
    }
  }
}

$template->assign(
    array(
      'setup_errors'=> $setup_errors,
    )
  );

// +-----------------------------------------------------------------------+
// |                           sending html code                           |
// +-----------------------------------------------------------------------+

$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
?>
